# Cosmos Go

## Run

```bash
go run main.go
```

### Sequence

```bash
http://0.0.0.0:1317/auth/accounts/$USERADDRESS
```

## Users

### Alice
- address "cosmos15tp4859d4cf80k9z8fqycgsh9d9jc278gl6ra2" with 
- mnemonic: "attend canoe twenty shallow beyond permit purpose eyebrow collect bunker hotel already garment globe wrong sunset hair cycle economy unlock ride magic grocery alien"

### Bob 
- address "cosmos1rmtyahxknmle8dxyt9zxauzhpmmex7h698yaf9" with 
- mnemonic: "sight quit diary ladder elbow crew inflict farm confirm mad ring entry because actor outside warrior hole can release asthma pride cloud ostrich joy"


The route guide server and client demonstrate how to use grpc go libraries to
perform unary, client streaming, server streaming and full duplex RPCs.

Please refer to [gRPC Basics: Go](https://grpc.io/docs/tutorials/basic/go.html) for more information.

See the definition of the route guide service in routeguide/route_guide.proto.

# Run the sample code
To compile and run the server, assuming you are in the root of the route_guide
folder, i.e., .../examples/route_guide/, simply:

```sh
$ go run server/server.go
```

Likewise, to run the client:

```sh
$ go run client/client.go
```

# Optional command line flags
The server and client both take optional command line flags. For example, the
client and server run without TLS by default. To enable TLS:

```sh
$ go run server/server.go -tls=true
```

and

```sh
$ go run client/client.go -tls=true
```
