import httpx
import base64

from cosmospy import generate_wallet, BIP32DerivationError, seed_to_privkey, privkey_to_pubkey, pubkey_to_address, Transaction
from unittest.mock import Mock
from l2tx import L2Transaction


def sendTx():
    privkey = bytes.fromhex(
        "6dcd05d7ac71e09d3cf7da666709ebd59362486ff9e99db0e8bc663570515afa")
    pubkey = privkey_to_pubkey(privkey)

    dummy_num = 1337

    tx_raw = Transaction(
        privkey=privkey,
        account_num=dummy_num,
        sequence=dummy_num,
        fee=dummy_num,
        gas=dummy_num,
        memo="",
        chain_id="",
        sync_mode="sync",
    )

    print(tx_raw)

    print("6")

    tx_avvy = L2Transaction(tx_raw)

    print(tx_avvy)
    print(f'\ntx_avvy 1: {tx_avvy}')

    tx_avvy.add_l3_node(privkey, pubkey, ["nodeOptions"])

    print(f'\ntx_avvy 2: {tx_avvy}')

    tx_result = tx_avvy._sign()
    print(f'\ntx_sign_result: {tx_result}')

    pushable_tx = tx_result.get_pushable()
    print(pushable_tx)
    
    rest_api = "http://159.223.19.171:1317/cosmos/tx/v1beta1/txs"
    tendermint_api = "http://159.223.19.171:26657/"

    res = httpx.post(rest_api, data=pushable_tx)
    print(res)

    return


if __name__ == '__main__':
    print("Start")
    sendTx()
