// THIS FILE IS GENERATED AUTOMATICALLY. DO NOT MODIFY.

import { StdFee } from "@cosmjs/launchpad";
import { SigningStargateClient } from "@cosmjs/stargate";
import { Registry, OfflineSigner, EncodeObject, DirectSecp256k1HdWallet } from "@cosmjs/proto-signing";
import { Api } from "./rest";
import { MsgDeleteL3Node } from "./types/voter/tx";
import { MsgCreateMessage } from "./types/voter/tx";
import { MsgUpdateAttachedUser } from "./types/voter/tx";
import { MsgCreateRollup } from "./types/voter/tx";
import { MsgDeleteRollup } from "./types/voter/tx";
import { MsgUpdateRollup } from "./types/voter/tx";
import { MsgDeleteMessage } from "./types/voter/tx";
import { MsgCreateL3Node } from "./types/voter/tx";
import { MsgUpdateMessage } from "./types/voter/tx";
import { MsgCreateAttachedUser } from "./types/voter/tx";
import { MsgUpdateL3Node } from "./types/voter/tx";
import { MsgDeleteAttachedUser } from "./types/voter/tx";


const types = [
  ["/cosmonaut.voter.voter.MsgDeleteL3Node", MsgDeleteL3Node],
  ["/cosmonaut.voter.voter.MsgCreateMessage", MsgCreateMessage],
  ["/cosmonaut.voter.voter.MsgUpdateAttachedUser", MsgUpdateAttachedUser],
  ["/cosmonaut.voter.voter.MsgCreateRollup", MsgCreateRollup],
  ["/cosmonaut.voter.voter.MsgDeleteRollup", MsgDeleteRollup],
  ["/cosmonaut.voter.voter.MsgUpdateRollup", MsgUpdateRollup],
  ["/cosmonaut.voter.voter.MsgDeleteMessage", MsgDeleteMessage],
  ["/cosmonaut.voter.voter.MsgCreateL3Node", MsgCreateL3Node],
  ["/cosmonaut.voter.voter.MsgUpdateMessage", MsgUpdateMessage],
  ["/cosmonaut.voter.voter.MsgCreateAttachedUser", MsgCreateAttachedUser],
  ["/cosmonaut.voter.voter.MsgUpdateL3Node", MsgUpdateL3Node],
  ["/cosmonaut.voter.voter.MsgDeleteAttachedUser", MsgDeleteAttachedUser],
  
];
export const MissingWalletError = new Error("wallet is required");

const registry = new Registry(<any>types);

const defaultFee = {
  amount: [],
  gas: "200000",
};

interface TxClientOptions {
  addr: string
}

interface SignAndBroadcastOptions {
  fee: StdFee,
  memo?: string
}

const txClient = async (wallet: OfflineSigner, { addr: addr }: TxClientOptions = { addr: "http://localhost:26657" }) => {
  if (!wallet) throw MissingWalletError;

  const client = await SigningStargateClient.connectWithSigner(addr, wallet, { registry });
  const { address } = (await wallet.getAccounts())[0];

  return {
    signAndBroadcast: (msgs: EncodeObject[], { fee, memo }: SignAndBroadcastOptions = {fee: defaultFee, memo: ""}) => client.signAndBroadcast(address, msgs, fee,memo),
    msgDeleteL3Node: (data: MsgDeleteL3Node): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgDeleteL3Node", value: data }),
    msgCreateMessage: (data: MsgCreateMessage): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgCreateMessage", value: data }),
    msgUpdateAttachedUser: (data: MsgUpdateAttachedUser): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgUpdateAttachedUser", value: data }),
    msgCreateRollup: (data: MsgCreateRollup): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgCreateRollup", value: data }),
    msgDeleteRollup: (data: MsgDeleteRollup): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgDeleteRollup", value: data }),
    msgUpdateRollup: (data: MsgUpdateRollup): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgUpdateRollup", value: data }),
    msgDeleteMessage: (data: MsgDeleteMessage): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgDeleteMessage", value: data }),
    msgCreateL3Node: (data: MsgCreateL3Node): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgCreateL3Node", value: data }),
    msgUpdateMessage: (data: MsgUpdateMessage): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgUpdateMessage", value: data }),
    msgCreateAttachedUser: (data: MsgCreateAttachedUser): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgCreateAttachedUser", value: data }),
    msgUpdateL3Node: (data: MsgUpdateL3Node): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgUpdateL3Node", value: data }),
    msgDeleteAttachedUser: (data: MsgDeleteAttachedUser): EncodeObject => ({ typeUrl: "/cosmonaut.voter.voter.MsgDeleteAttachedUser", value: data }),
    
  };
};

interface QueryClientOptions {
  addr: string
}

const queryClient = async ({ addr: addr }: QueryClientOptions = { addr: "http://localhost:1317" }) => {
  return new Api({ baseUrl: addr });
};

export {
  txClient,
  queryClient,
};
