/* eslint-disable */
import { Writer, Reader } from "protobufjs/minimal";

export const protobufPackage = "cosmonaut.voter.voter";

export interface AttachedUser {
  iidapId: number;
  account: number;
  userName: string;
  creator: string;
}

const baseAttachedUser: object = {
  iidapId: 0,
  account: 0,
  userName: "",
  creator: "",
};

export const AttachedUser = {
  encode(message: AttachedUser, writer: Writer = Writer.create()): Writer {
    if (message.iidapId !== 0) {
      writer.uint32(8).int32(message.iidapId);
    }
    if (message.account !== 0) {
      writer.uint32(16).int32(message.account);
    }
    if (message.userName !== "") {
      writer.uint32(26).string(message.userName);
    }
    if (message.creator !== "") {
      writer.uint32(34).string(message.creator);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): AttachedUser {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseAttachedUser } as AttachedUser;
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.iidapId = reader.int32();
          break;
        case 2:
          message.account = reader.int32();
          break;
        case 3:
          message.userName = reader.string();
          break;
        case 4:
          message.creator = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): AttachedUser {
    const message = { ...baseAttachedUser } as AttachedUser;
    if (object.iidapId !== undefined && object.iidapId !== null) {
      message.iidapId = Number(object.iidapId);
    } else {
      message.iidapId = 0;
    }
    if (object.account !== undefined && object.account !== null) {
      message.account = Number(object.account);
    } else {
      message.account = 0;
    }
    if (object.userName !== undefined && object.userName !== null) {
      message.userName = String(object.userName);
    } else {
      message.userName = "";
    }
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    return message;
  },

  toJSON(message: AttachedUser): unknown {
    const obj: any = {};
    message.iidapId !== undefined && (obj.iidapId = message.iidapId);
    message.account !== undefined && (obj.account = message.account);
    message.userName !== undefined && (obj.userName = message.userName);
    message.creator !== undefined && (obj.creator = message.creator);
    return obj;
  },

  fromPartial(object: DeepPartial<AttachedUser>): AttachedUser {
    const message = { ...baseAttachedUser } as AttachedUser;
    if (object.iidapId !== undefined && object.iidapId !== null) {
      message.iidapId = object.iidapId;
    } else {
      message.iidapId = 0;
    }
    if (object.account !== undefined && object.account !== null) {
      message.account = object.account;
    } else {
      message.account = 0;
    }
    if (object.userName !== undefined && object.userName !== null) {
      message.userName = object.userName;
    } else {
      message.userName = "";
    }
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    return message;
  },
};

type Builtin = Date | Function | Uint8Array | string | number | undefined;
export type DeepPartial<T> = T extends Builtin
  ? T
  : T extends Array<infer U>
  ? Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U>
  ? ReadonlyArray<DeepPartial<U>>
  : T extends {}
  ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;
