/* eslint-disable */
import * as Long from "long";
import { util, configure, Writer, Reader } from "protobufjs/minimal";
import { Rollup } from "../voter/rollup";
import { Message } from "../voter/message";
import { L3Node } from "../voter/l_3_node";
import { AttachedUser } from "../voter/attached_user";

export const protobufPackage = "cosmonaut.voter.voter";

/** GenesisState defines the voter module's genesis state. */
export interface GenesisState {
  rollupList: Rollup[];
  rollupCount: number;
  messageList: Message[];
  messageCount: number;
  l3NodeList: L3Node[];
  l3NodeCount: number;
  /** this line is used by starport scaffolding # genesis/proto/state */
  attachedUserList: AttachedUser[];
}

const baseGenesisState: object = {
  rollupCount: 0,
  messageCount: 0,
  l3NodeCount: 0,
};

export const GenesisState = {
  encode(message: GenesisState, writer: Writer = Writer.create()): Writer {
    for (const v of message.rollupList) {
      Rollup.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.rollupCount !== 0) {
      writer.uint32(16).uint64(message.rollupCount);
    }
    for (const v of message.messageList) {
      Message.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    if (message.messageCount !== 0) {
      writer.uint32(32).uint64(message.messageCount);
    }
    for (const v of message.l3NodeList) {
      L3Node.encode(v!, writer.uint32(42).fork()).ldelim();
    }
    if (message.l3NodeCount !== 0) {
      writer.uint32(48).uint64(message.l3NodeCount);
    }
    for (const v of message.attachedUserList) {
      AttachedUser.encode(v!, writer.uint32(58).fork()).ldelim();
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): GenesisState {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseGenesisState } as GenesisState;
    message.rollupList = [];
    message.messageList = [];
    message.l3NodeList = [];
    message.attachedUserList = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.rollupList.push(Rollup.decode(reader, reader.uint32()));
          break;
        case 2:
          message.rollupCount = longToNumber(reader.uint64() as Long);
          break;
        case 3:
          message.messageList.push(Message.decode(reader, reader.uint32()));
          break;
        case 4:
          message.messageCount = longToNumber(reader.uint64() as Long);
          break;
        case 5:
          message.l3NodeList.push(L3Node.decode(reader, reader.uint32()));
          break;
        case 6:
          message.l3NodeCount = longToNumber(reader.uint64() as Long);
          break;
        case 7:
          message.attachedUserList.push(
            AttachedUser.decode(reader, reader.uint32())
          );
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): GenesisState {
    const message = { ...baseGenesisState } as GenesisState;
    message.rollupList = [];
    message.messageList = [];
    message.l3NodeList = [];
    message.attachedUserList = [];
    if (object.rollupList !== undefined && object.rollupList !== null) {
      for (const e of object.rollupList) {
        message.rollupList.push(Rollup.fromJSON(e));
      }
    }
    if (object.rollupCount !== undefined && object.rollupCount !== null) {
      message.rollupCount = Number(object.rollupCount);
    } else {
      message.rollupCount = 0;
    }
    if (object.messageList !== undefined && object.messageList !== null) {
      for (const e of object.messageList) {
        message.messageList.push(Message.fromJSON(e));
      }
    }
    if (object.messageCount !== undefined && object.messageCount !== null) {
      message.messageCount = Number(object.messageCount);
    } else {
      message.messageCount = 0;
    }
    if (object.l3NodeList !== undefined && object.l3NodeList !== null) {
      for (const e of object.l3NodeList) {
        message.l3NodeList.push(L3Node.fromJSON(e));
      }
    }
    if (object.l3NodeCount !== undefined && object.l3NodeCount !== null) {
      message.l3NodeCount = Number(object.l3NodeCount);
    } else {
      message.l3NodeCount = 0;
    }
    if (
      object.attachedUserList !== undefined &&
      object.attachedUserList !== null
    ) {
      for (const e of object.attachedUserList) {
        message.attachedUserList.push(AttachedUser.fromJSON(e));
      }
    }
    return message;
  },

  toJSON(message: GenesisState): unknown {
    const obj: any = {};
    if (message.rollupList) {
      obj.rollupList = message.rollupList.map((e) =>
        e ? Rollup.toJSON(e) : undefined
      );
    } else {
      obj.rollupList = [];
    }
    message.rollupCount !== undefined &&
      (obj.rollupCount = message.rollupCount);
    if (message.messageList) {
      obj.messageList = message.messageList.map((e) =>
        e ? Message.toJSON(e) : undefined
      );
    } else {
      obj.messageList = [];
    }
    message.messageCount !== undefined &&
      (obj.messageCount = message.messageCount);
    if (message.l3NodeList) {
      obj.l3NodeList = message.l3NodeList.map((e) =>
        e ? L3Node.toJSON(e) : undefined
      );
    } else {
      obj.l3NodeList = [];
    }
    message.l3NodeCount !== undefined &&
      (obj.l3NodeCount = message.l3NodeCount);
    if (message.attachedUserList) {
      obj.attachedUserList = message.attachedUserList.map((e) =>
        e ? AttachedUser.toJSON(e) : undefined
      );
    } else {
      obj.attachedUserList = [];
    }
    return obj;
  },

  fromPartial(object: DeepPartial<GenesisState>): GenesisState {
    const message = { ...baseGenesisState } as GenesisState;
    message.rollupList = [];
    message.messageList = [];
    message.l3NodeList = [];
    message.attachedUserList = [];
    if (object.rollupList !== undefined && object.rollupList !== null) {
      for (const e of object.rollupList) {
        message.rollupList.push(Rollup.fromPartial(e));
      }
    }
    if (object.rollupCount !== undefined && object.rollupCount !== null) {
      message.rollupCount = object.rollupCount;
    } else {
      message.rollupCount = 0;
    }
    if (object.messageList !== undefined && object.messageList !== null) {
      for (const e of object.messageList) {
        message.messageList.push(Message.fromPartial(e));
      }
    }
    if (object.messageCount !== undefined && object.messageCount !== null) {
      message.messageCount = object.messageCount;
    } else {
      message.messageCount = 0;
    }
    if (object.l3NodeList !== undefined && object.l3NodeList !== null) {
      for (const e of object.l3NodeList) {
        message.l3NodeList.push(L3Node.fromPartial(e));
      }
    }
    if (object.l3NodeCount !== undefined && object.l3NodeCount !== null) {
      message.l3NodeCount = object.l3NodeCount;
    } else {
      message.l3NodeCount = 0;
    }
    if (
      object.attachedUserList !== undefined &&
      object.attachedUserList !== null
    ) {
      for (const e of object.attachedUserList) {
        message.attachedUserList.push(AttachedUser.fromPartial(e));
      }
    }
    return message;
  },
};

declare var self: any | undefined;
declare var window: any | undefined;
var globalThis: any = (() => {
  if (typeof globalThis !== "undefined") return globalThis;
  if (typeof self !== "undefined") return self;
  if (typeof window !== "undefined") return window;
  if (typeof global !== "undefined") return global;
  throw "Unable to locate global object";
})();

type Builtin = Date | Function | Uint8Array | string | number | undefined;
export type DeepPartial<T> = T extends Builtin
  ? T
  : T extends Array<infer U>
  ? Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U>
  ? ReadonlyArray<DeepPartial<U>>
  : T extends {}
  ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function longToNumber(long: Long): number {
  if (long.gt(Number.MAX_SAFE_INTEGER)) {
    throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
  }
  return long.toNumber();
}

if (util.Long !== Long) {
  util.Long = Long as any;
  configure();
}
