import { Reader, Writer } from "protobufjs/minimal";
import { Rollup } from "../voter/rollup";
import { PageRequest, PageResponse } from "../cosmos/base/query/v1beta1/pagination";
import { Message } from "../voter/message";
import { L3Node } from "../voter/l_3_node";
import { AttachedUser } from "../voter/attached_user";
export declare const protobufPackage = "cosmonaut.voter.voter";
export interface QueryGetRollupRequest {
    id: number;
}
export interface QueryGetRollupResponse {
    Rollup: Rollup | undefined;
}
export interface QueryAllRollupRequest {
    pagination: PageRequest | undefined;
}
export interface QueryAllRollupResponse {
    Rollup: Rollup[];
    pagination: PageResponse | undefined;
}
export interface QueryGetMessageRequest {
    id: number;
}
export interface QueryGetMessageResponse {
    Message: Message | undefined;
}
export interface QueryAllMessageRequest {
    pagination: PageRequest | undefined;
}
export interface QueryAllMessageResponse {
    Message: Message[];
    pagination: PageResponse | undefined;
}
export interface QueryGetL3NodeRequest {
    id: number;
}
export interface QueryGetL3NodeResponse {
    L3Node: L3Node | undefined;
}
export interface QueryAllL3NodeRequest {
    pagination: PageRequest | undefined;
}
export interface QueryAllL3NodeResponse {
    L3Node: L3Node[];
    pagination: PageResponse | undefined;
}
export interface QueryGetAttachedUserRequest {
    iidapId: number;
    account: number;
}
export interface QueryGetAttachedUserResponse {
    attachedUser: AttachedUser | undefined;
}
export interface QueryAllAttachedUserRequest {
    pagination: PageRequest | undefined;
}
export interface QueryAllAttachedUserResponse {
    attachedUser: AttachedUser[];
    pagination: PageResponse | undefined;
}
export declare const QueryGetRollupRequest: {
    encode(message: QueryGetRollupRequest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryGetRollupRequest;
    fromJSON(object: any): QueryGetRollupRequest;
    toJSON(message: QueryGetRollupRequest): unknown;
    fromPartial(object: DeepPartial<QueryGetRollupRequest>): QueryGetRollupRequest;
};
export declare const QueryGetRollupResponse: {
    encode(message: QueryGetRollupResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryGetRollupResponse;
    fromJSON(object: any): QueryGetRollupResponse;
    toJSON(message: QueryGetRollupResponse): unknown;
    fromPartial(object: DeepPartial<QueryGetRollupResponse>): QueryGetRollupResponse;
};
export declare const QueryAllRollupRequest: {
    encode(message: QueryAllRollupRequest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryAllRollupRequest;
    fromJSON(object: any): QueryAllRollupRequest;
    toJSON(message: QueryAllRollupRequest): unknown;
    fromPartial(object: DeepPartial<QueryAllRollupRequest>): QueryAllRollupRequest;
};
export declare const QueryAllRollupResponse: {
    encode(message: QueryAllRollupResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryAllRollupResponse;
    fromJSON(object: any): QueryAllRollupResponse;
    toJSON(message: QueryAllRollupResponse): unknown;
    fromPartial(object: DeepPartial<QueryAllRollupResponse>): QueryAllRollupResponse;
};
export declare const QueryGetMessageRequest: {
    encode(message: QueryGetMessageRequest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryGetMessageRequest;
    fromJSON(object: any): QueryGetMessageRequest;
    toJSON(message: QueryGetMessageRequest): unknown;
    fromPartial(object: DeepPartial<QueryGetMessageRequest>): QueryGetMessageRequest;
};
export declare const QueryGetMessageResponse: {
    encode(message: QueryGetMessageResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryGetMessageResponse;
    fromJSON(object: any): QueryGetMessageResponse;
    toJSON(message: QueryGetMessageResponse): unknown;
    fromPartial(object: DeepPartial<QueryGetMessageResponse>): QueryGetMessageResponse;
};
export declare const QueryAllMessageRequest: {
    encode(message: QueryAllMessageRequest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryAllMessageRequest;
    fromJSON(object: any): QueryAllMessageRequest;
    toJSON(message: QueryAllMessageRequest): unknown;
    fromPartial(object: DeepPartial<QueryAllMessageRequest>): QueryAllMessageRequest;
};
export declare const QueryAllMessageResponse: {
    encode(message: QueryAllMessageResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryAllMessageResponse;
    fromJSON(object: any): QueryAllMessageResponse;
    toJSON(message: QueryAllMessageResponse): unknown;
    fromPartial(object: DeepPartial<QueryAllMessageResponse>): QueryAllMessageResponse;
};
export declare const QueryGetL3NodeRequest: {
    encode(message: QueryGetL3NodeRequest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryGetL3NodeRequest;
    fromJSON(object: any): QueryGetL3NodeRequest;
    toJSON(message: QueryGetL3NodeRequest): unknown;
    fromPartial(object: DeepPartial<QueryGetL3NodeRequest>): QueryGetL3NodeRequest;
};
export declare const QueryGetL3NodeResponse: {
    encode(message: QueryGetL3NodeResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryGetL3NodeResponse;
    fromJSON(object: any): QueryGetL3NodeResponse;
    toJSON(message: QueryGetL3NodeResponse): unknown;
    fromPartial(object: DeepPartial<QueryGetL3NodeResponse>): QueryGetL3NodeResponse;
};
export declare const QueryAllL3NodeRequest: {
    encode(message: QueryAllL3NodeRequest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryAllL3NodeRequest;
    fromJSON(object: any): QueryAllL3NodeRequest;
    toJSON(message: QueryAllL3NodeRequest): unknown;
    fromPartial(object: DeepPartial<QueryAllL3NodeRequest>): QueryAllL3NodeRequest;
};
export declare const QueryAllL3NodeResponse: {
    encode(message: QueryAllL3NodeResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryAllL3NodeResponse;
    fromJSON(object: any): QueryAllL3NodeResponse;
    toJSON(message: QueryAllL3NodeResponse): unknown;
    fromPartial(object: DeepPartial<QueryAllL3NodeResponse>): QueryAllL3NodeResponse;
};
export declare const QueryGetAttachedUserRequest: {
    encode(message: QueryGetAttachedUserRequest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryGetAttachedUserRequest;
    fromJSON(object: any): QueryGetAttachedUserRequest;
    toJSON(message: QueryGetAttachedUserRequest): unknown;
    fromPartial(object: DeepPartial<QueryGetAttachedUserRequest>): QueryGetAttachedUserRequest;
};
export declare const QueryGetAttachedUserResponse: {
    encode(message: QueryGetAttachedUserResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryGetAttachedUserResponse;
    fromJSON(object: any): QueryGetAttachedUserResponse;
    toJSON(message: QueryGetAttachedUserResponse): unknown;
    fromPartial(object: DeepPartial<QueryGetAttachedUserResponse>): QueryGetAttachedUserResponse;
};
export declare const QueryAllAttachedUserRequest: {
    encode(message: QueryAllAttachedUserRequest, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryAllAttachedUserRequest;
    fromJSON(object: any): QueryAllAttachedUserRequest;
    toJSON(message: QueryAllAttachedUserRequest): unknown;
    fromPartial(object: DeepPartial<QueryAllAttachedUserRequest>): QueryAllAttachedUserRequest;
};
export declare const QueryAllAttachedUserResponse: {
    encode(message: QueryAllAttachedUserResponse, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number): QueryAllAttachedUserResponse;
    fromJSON(object: any): QueryAllAttachedUserResponse;
    toJSON(message: QueryAllAttachedUserResponse): unknown;
    fromPartial(object: DeepPartial<QueryAllAttachedUserResponse>): QueryAllAttachedUserResponse;
};
/** Query defines the gRPC querier service. */
export interface Query {
    /** Queries a rollup by id. */
    Rollup(request: QueryGetRollupRequest): Promise<QueryGetRollupResponse>;
    /** Queries a list of rollup items. */
    RollupAll(request: QueryAllRollupRequest): Promise<QueryAllRollupResponse>;
    /** Queries a message by id. */
    Message(request: QueryGetMessageRequest): Promise<QueryGetMessageResponse>;
    /** Queries a list of message items. */
    MessageAll(request: QueryAllMessageRequest): Promise<QueryAllMessageResponse>;
    /** Queries a l3Node by id. */
    L3Node(request: QueryGetL3NodeRequest): Promise<QueryGetL3NodeResponse>;
    /** Queries a list of l3Node items. */
    L3NodeAll(request: QueryAllL3NodeRequest): Promise<QueryAllL3NodeResponse>;
    /** Queries a attachedUser by index. */
    AttachedUser(request: QueryGetAttachedUserRequest): Promise<QueryGetAttachedUserResponse>;
    /** Queries a list of attachedUser items. */
    AttachedUserAll(request: QueryAllAttachedUserRequest): Promise<QueryAllAttachedUserResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: Rpc);
    Rollup(request: QueryGetRollupRequest): Promise<QueryGetRollupResponse>;
    RollupAll(request: QueryAllRollupRequest): Promise<QueryAllRollupResponse>;
    Message(request: QueryGetMessageRequest): Promise<QueryGetMessageResponse>;
    MessageAll(request: QueryAllMessageRequest): Promise<QueryAllMessageResponse>;
    L3Node(request: QueryGetL3NodeRequest): Promise<QueryGetL3NodeResponse>;
    L3NodeAll(request: QueryAllL3NodeRequest): Promise<QueryAllL3NodeResponse>;
    AttachedUser(request: QueryGetAttachedUserRequest): Promise<QueryGetAttachedUserResponse>;
    AttachedUserAll(request: QueryAllAttachedUserRequest): Promise<QueryAllAttachedUserResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
declare type Builtin = Date | Function | Uint8Array | string | number | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
