/* eslint-disable */
import * as Long from "long";
import { util, configure, Writer, Reader } from "protobufjs/minimal";

export const protobufPackage = "cosmonaut.voter.voter";

export interface Rollup {
  id: number;
  prevHash: string;
  currentHash: string;
  dsUri: string;
  inbox: string[];
  creator: string;
}

const baseRollup: object = {
  id: 0,
  prevHash: "",
  currentHash: "",
  dsUri: "",
  inbox: "",
  creator: "",
};

export const Rollup = {
  encode(message: Rollup, writer: Writer = Writer.create()): Writer {
    if (message.id !== 0) {
      writer.uint32(8).uint64(message.id);
    }
    if (message.prevHash !== "") {
      writer.uint32(18).string(message.prevHash);
    }
    if (message.currentHash !== "") {
      writer.uint32(26).string(message.currentHash);
    }
    if (message.dsUri !== "") {
      writer.uint32(34).string(message.dsUri);
    }
    for (const v of message.inbox) {
      writer.uint32(42).string(v!);
    }
    if (message.creator !== "") {
      writer.uint32(50).string(message.creator);
    }
    return writer;
  },

  decode(input: Reader | Uint8Array, length?: number): Rollup {
    const reader = input instanceof Uint8Array ? new Reader(input) : input;
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = { ...baseRollup } as Rollup;
    message.inbox = [];
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.id = longToNumber(reader.uint64() as Long);
          break;
        case 2:
          message.prevHash = reader.string();
          break;
        case 3:
          message.currentHash = reader.string();
          break;
        case 4:
          message.dsUri = reader.string();
          break;
        case 5:
          message.inbox.push(reader.string());
          break;
        case 6:
          message.creator = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Rollup {
    const message = { ...baseRollup } as Rollup;
    message.inbox = [];
    if (object.id !== undefined && object.id !== null) {
      message.id = Number(object.id);
    } else {
      message.id = 0;
    }
    if (object.prevHash !== undefined && object.prevHash !== null) {
      message.prevHash = String(object.prevHash);
    } else {
      message.prevHash = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = String(object.currentHash);
    } else {
      message.currentHash = "";
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = String(object.dsUri);
    } else {
      message.dsUri = "";
    }
    if (object.inbox !== undefined && object.inbox !== null) {
      for (const e of object.inbox) {
        message.inbox.push(String(e));
      }
    }
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = String(object.creator);
    } else {
      message.creator = "";
    }
    return message;
  },

  toJSON(message: Rollup): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    message.prevHash !== undefined && (obj.prevHash = message.prevHash);
    message.currentHash !== undefined &&
      (obj.currentHash = message.currentHash);
    message.dsUri !== undefined && (obj.dsUri = message.dsUri);
    if (message.inbox) {
      obj.inbox = message.inbox.map((e) => e);
    } else {
      obj.inbox = [];
    }
    message.creator !== undefined && (obj.creator = message.creator);
    return obj;
  },

  fromPartial(object: DeepPartial<Rollup>): Rollup {
    const message = { ...baseRollup } as Rollup;
    message.inbox = [];
    if (object.id !== undefined && object.id !== null) {
      message.id = object.id;
    } else {
      message.id = 0;
    }
    if (object.prevHash !== undefined && object.prevHash !== null) {
      message.prevHash = object.prevHash;
    } else {
      message.prevHash = "";
    }
    if (object.currentHash !== undefined && object.currentHash !== null) {
      message.currentHash = object.currentHash;
    } else {
      message.currentHash = "";
    }
    if (object.dsUri !== undefined && object.dsUri !== null) {
      message.dsUri = object.dsUri;
    } else {
      message.dsUri = "";
    }
    if (object.inbox !== undefined && object.inbox !== null) {
      for (const e of object.inbox) {
        message.inbox.push(e);
      }
    }
    if (object.creator !== undefined && object.creator !== null) {
      message.creator = object.creator;
    } else {
      message.creator = "";
    }
    return message;
  },
};

declare var self: any | undefined;
declare var window: any | undefined;
var globalThis: any = (() => {
  if (typeof globalThis !== "undefined") return globalThis;
  if (typeof self !== "undefined") return self;
  if (typeof window !== "undefined") return window;
  if (typeof global !== "undefined") return global;
  throw "Unable to locate global object";
})();

type Builtin = Date | Function | Uint8Array | string | number | undefined;
export type DeepPartial<T> = T extends Builtin
  ? T
  : T extends Array<infer U>
  ? Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U>
  ? ReadonlyArray<DeepPartial<U>>
  : T extends {}
  ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function longToNumber(long: Long): number {
  if (long.gt(Number.MAX_SAFE_INTEGER)) {
    throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
  }
  return long.toNumber();
}

if (util.Long !== Long) {
  util.Long = Long as any;
  configure();
}
