/* eslint-disable */
import { Reader, util, configure, Writer } from "protobufjs/minimal";
import * as Long from "long";
export const protobufPackage = "cosmonaut.voter.voter";
const baseMsgCreateRollup = {
    creator: "",
    prevHash: "",
    currentHash: "",
    dsUri: "",
    inbox: "",
};
export const MsgCreateRollup = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.prevHash !== "") {
            writer.uint32(18).string(message.prevHash);
        }
        if (message.currentHash !== "") {
            writer.uint32(26).string(message.currentHash);
        }
        if (message.dsUri !== "") {
            writer.uint32(34).string(message.dsUri);
        }
        for (const v of message.inbox) {
            writer.uint32(42).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgCreateRollup };
        message.inbox = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.prevHash = reader.string();
                    break;
                case 3:
                    message.currentHash = reader.string();
                    break;
                case 4:
                    message.dsUri = reader.string();
                    break;
                case 5:
                    message.inbox.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgCreateRollup };
        message.inbox = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.prevHash !== undefined && object.prevHash !== null) {
            message.prevHash = String(object.prevHash);
        }
        else {
            message.prevHash = "";
        }
        if (object.currentHash !== undefined && object.currentHash !== null) {
            message.currentHash = String(object.currentHash);
        }
        else {
            message.currentHash = "";
        }
        if (object.dsUri !== undefined && object.dsUri !== null) {
            message.dsUri = String(object.dsUri);
        }
        else {
            message.dsUri = "";
        }
        if (object.inbox !== undefined && object.inbox !== null) {
            for (const e of object.inbox) {
                message.inbox.push(String(e));
            }
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.prevHash !== undefined && (obj.prevHash = message.prevHash);
        message.currentHash !== undefined &&
            (obj.currentHash = message.currentHash);
        message.dsUri !== undefined && (obj.dsUri = message.dsUri);
        if (message.inbox) {
            obj.inbox = message.inbox.map((e) => e);
        }
        else {
            obj.inbox = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgCreateRollup };
        message.inbox = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.prevHash !== undefined && object.prevHash !== null) {
            message.prevHash = object.prevHash;
        }
        else {
            message.prevHash = "";
        }
        if (object.currentHash !== undefined && object.currentHash !== null) {
            message.currentHash = object.currentHash;
        }
        else {
            message.currentHash = "";
        }
        if (object.dsUri !== undefined && object.dsUri !== null) {
            message.dsUri = object.dsUri;
        }
        else {
            message.dsUri = "";
        }
        if (object.inbox !== undefined && object.inbox !== null) {
            for (const e of object.inbox) {
                message.inbox.push(e);
            }
        }
        return message;
    },
};
const baseMsgCreateRollupResponse = { id: 0 };
export const MsgCreateRollupResponse = {
    encode(message, writer = Writer.create()) {
        if (message.id !== 0) {
            writer.uint32(8).uint64(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgCreateRollupResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = longToNumber(reader.uint64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseMsgCreateRollupResponse,
        };
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseMsgCreateRollupResponse,
        };
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        return message;
    },
};
const baseMsgUpdateRollup = {
    creator: "",
    id: 0,
    prevHash: "",
    currentHash: "",
    dsUri: "",
    inbox: "",
};
export const MsgUpdateRollup = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.id !== 0) {
            writer.uint32(16).uint64(message.id);
        }
        if (message.prevHash !== "") {
            writer.uint32(26).string(message.prevHash);
        }
        if (message.currentHash !== "") {
            writer.uint32(34).string(message.currentHash);
        }
        if (message.dsUri !== "") {
            writer.uint32(42).string(message.dsUri);
        }
        for (const v of message.inbox) {
            writer.uint32(50).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgUpdateRollup };
        message.inbox = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.id = longToNumber(reader.uint64());
                    break;
                case 3:
                    message.prevHash = reader.string();
                    break;
                case 4:
                    message.currentHash = reader.string();
                    break;
                case 5:
                    message.dsUri = reader.string();
                    break;
                case 6:
                    message.inbox.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgUpdateRollup };
        message.inbox = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        if (object.prevHash !== undefined && object.prevHash !== null) {
            message.prevHash = String(object.prevHash);
        }
        else {
            message.prevHash = "";
        }
        if (object.currentHash !== undefined && object.currentHash !== null) {
            message.currentHash = String(object.currentHash);
        }
        else {
            message.currentHash = "";
        }
        if (object.dsUri !== undefined && object.dsUri !== null) {
            message.dsUri = String(object.dsUri);
        }
        else {
            message.dsUri = "";
        }
        if (object.inbox !== undefined && object.inbox !== null) {
            for (const e of object.inbox) {
                message.inbox.push(String(e));
            }
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.id !== undefined && (obj.id = message.id);
        message.prevHash !== undefined && (obj.prevHash = message.prevHash);
        message.currentHash !== undefined &&
            (obj.currentHash = message.currentHash);
        message.dsUri !== undefined && (obj.dsUri = message.dsUri);
        if (message.inbox) {
            obj.inbox = message.inbox.map((e) => e);
        }
        else {
            obj.inbox = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgUpdateRollup };
        message.inbox = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        if (object.prevHash !== undefined && object.prevHash !== null) {
            message.prevHash = object.prevHash;
        }
        else {
            message.prevHash = "";
        }
        if (object.currentHash !== undefined && object.currentHash !== null) {
            message.currentHash = object.currentHash;
        }
        else {
            message.currentHash = "";
        }
        if (object.dsUri !== undefined && object.dsUri !== null) {
            message.dsUri = object.dsUri;
        }
        else {
            message.dsUri = "";
        }
        if (object.inbox !== undefined && object.inbox !== null) {
            for (const e of object.inbox) {
                message.inbox.push(e);
            }
        }
        return message;
    },
};
const baseMsgUpdateRollupResponse = {};
export const MsgUpdateRollupResponse = {
    encode(_, writer = Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgUpdateRollupResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const message = {
            ...baseMsgUpdateRollupResponse,
        };
        return message;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = {
            ...baseMsgUpdateRollupResponse,
        };
        return message;
    },
};
const baseMsgDeleteRollup = { creator: "", id: 0 };
export const MsgDeleteRollup = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.id !== 0) {
            writer.uint32(16).uint64(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgDeleteRollup };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.id = longToNumber(reader.uint64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgDeleteRollup };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgDeleteRollup };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        return message;
    },
};
const baseMsgDeleteRollupResponse = {};
export const MsgDeleteRollupResponse = {
    encode(_, writer = Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgDeleteRollupResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const message = {
            ...baseMsgDeleteRollupResponse,
        };
        return message;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = {
            ...baseMsgDeleteRollupResponse,
        };
        return message;
    },
};
const baseMsgCreateMessage = {
    creator: "",
    status: "",
    name: "",
    data: "",
};
export const MsgCreateMessage = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.status !== "") {
            writer.uint32(18).string(message.status);
        }
        if (message.name !== "") {
            writer.uint32(26).string(message.name);
        }
        for (const v of message.data) {
            writer.uint32(34).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgCreateMessage };
        message.data = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.status = reader.string();
                    break;
                case 3:
                    message.name = reader.string();
                    break;
                case 4:
                    message.data.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgCreateMessage };
        message.data = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.status !== undefined && object.status !== null) {
            message.status = String(object.status);
        }
        else {
            message.status = "";
        }
        if (object.name !== undefined && object.name !== null) {
            message.name = String(object.name);
        }
        else {
            message.name = "";
        }
        if (object.data !== undefined && object.data !== null) {
            for (const e of object.data) {
                message.data.push(String(e));
            }
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.status !== undefined && (obj.status = message.status);
        message.name !== undefined && (obj.name = message.name);
        if (message.data) {
            obj.data = message.data.map((e) => e);
        }
        else {
            obj.data = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgCreateMessage };
        message.data = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.status !== undefined && object.status !== null) {
            message.status = object.status;
        }
        else {
            message.status = "";
        }
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        else {
            message.name = "";
        }
        if (object.data !== undefined && object.data !== null) {
            for (const e of object.data) {
                message.data.push(e);
            }
        }
        return message;
    },
};
const baseMsgCreateMessageResponse = { id: 0 };
export const MsgCreateMessageResponse = {
    encode(message, writer = Writer.create()) {
        if (message.id !== 0) {
            writer.uint32(8).uint64(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgCreateMessageResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = longToNumber(reader.uint64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseMsgCreateMessageResponse,
        };
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseMsgCreateMessageResponse,
        };
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        return message;
    },
};
const baseMsgUpdateMessage = {
    creator: "",
    id: 0,
    status: "",
    name: "",
    data: "",
};
export const MsgUpdateMessage = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.id !== 0) {
            writer.uint32(16).uint64(message.id);
        }
        if (message.status !== "") {
            writer.uint32(26).string(message.status);
        }
        if (message.name !== "") {
            writer.uint32(34).string(message.name);
        }
        for (const v of message.data) {
            writer.uint32(42).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgUpdateMessage };
        message.data = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.id = longToNumber(reader.uint64());
                    break;
                case 3:
                    message.status = reader.string();
                    break;
                case 4:
                    message.name = reader.string();
                    break;
                case 5:
                    message.data.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgUpdateMessage };
        message.data = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        if (object.status !== undefined && object.status !== null) {
            message.status = String(object.status);
        }
        else {
            message.status = "";
        }
        if (object.name !== undefined && object.name !== null) {
            message.name = String(object.name);
        }
        else {
            message.name = "";
        }
        if (object.data !== undefined && object.data !== null) {
            for (const e of object.data) {
                message.data.push(String(e));
            }
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.id !== undefined && (obj.id = message.id);
        message.status !== undefined && (obj.status = message.status);
        message.name !== undefined && (obj.name = message.name);
        if (message.data) {
            obj.data = message.data.map((e) => e);
        }
        else {
            obj.data = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgUpdateMessage };
        message.data = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        if (object.status !== undefined && object.status !== null) {
            message.status = object.status;
        }
        else {
            message.status = "";
        }
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        else {
            message.name = "";
        }
        if (object.data !== undefined && object.data !== null) {
            for (const e of object.data) {
                message.data.push(e);
            }
        }
        return message;
    },
};
const baseMsgUpdateMessageResponse = {};
export const MsgUpdateMessageResponse = {
    encode(_, writer = Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgUpdateMessageResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const message = {
            ...baseMsgUpdateMessageResponse,
        };
        return message;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = {
            ...baseMsgUpdateMessageResponse,
        };
        return message;
    },
};
const baseMsgDeleteMessage = { creator: "", id: 0 };
export const MsgDeleteMessage = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.id !== 0) {
            writer.uint32(16).uint64(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgDeleteMessage };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.id = longToNumber(reader.uint64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgDeleteMessage };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgDeleteMessage };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        return message;
    },
};
const baseMsgDeleteMessageResponse = {};
export const MsgDeleteMessageResponse = {
    encode(_, writer = Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgDeleteMessageResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const message = {
            ...baseMsgDeleteMessageResponse,
        };
        return message;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = {
            ...baseMsgDeleteMessageResponse,
        };
        return message;
    },
};
const baseMsgCreateL3Node = { creator: "", publicKey: "", options: "" };
export const MsgCreateL3Node = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.publicKey !== "") {
            writer.uint32(18).string(message.publicKey);
        }
        for (const v of message.options) {
            writer.uint32(26).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgCreateL3Node };
        message.options = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.publicKey = reader.string();
                    break;
                case 3:
                    message.options.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgCreateL3Node };
        message.options = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.publicKey !== undefined && object.publicKey !== null) {
            message.publicKey = String(object.publicKey);
        }
        else {
            message.publicKey = "";
        }
        if (object.options !== undefined && object.options !== null) {
            for (const e of object.options) {
                message.options.push(String(e));
            }
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.publicKey !== undefined && (obj.publicKey = message.publicKey);
        if (message.options) {
            obj.options = message.options.map((e) => e);
        }
        else {
            obj.options = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgCreateL3Node };
        message.options = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.publicKey !== undefined && object.publicKey !== null) {
            message.publicKey = object.publicKey;
        }
        else {
            message.publicKey = "";
        }
        if (object.options !== undefined && object.options !== null) {
            for (const e of object.options) {
                message.options.push(e);
            }
        }
        return message;
    },
};
const baseMsgCreateL3NodeResponse = { id: 0 };
export const MsgCreateL3NodeResponse = {
    encode(message, writer = Writer.create()) {
        if (message.id !== 0) {
            writer.uint32(8).uint64(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgCreateL3NodeResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = longToNumber(reader.uint64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = {
            ...baseMsgCreateL3NodeResponse,
        };
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        const message = {
            ...baseMsgCreateL3NodeResponse,
        };
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        return message;
    },
};
const baseMsgUpdateL3Node = {
    creator: "",
    id: 0,
    publicKey: "",
    options: "",
};
export const MsgUpdateL3Node = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.id !== 0) {
            writer.uint32(16).uint64(message.id);
        }
        if (message.publicKey !== "") {
            writer.uint32(26).string(message.publicKey);
        }
        for (const v of message.options) {
            writer.uint32(34).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgUpdateL3Node };
        message.options = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.id = longToNumber(reader.uint64());
                    break;
                case 3:
                    message.publicKey = reader.string();
                    break;
                case 4:
                    message.options.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgUpdateL3Node };
        message.options = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        if (object.publicKey !== undefined && object.publicKey !== null) {
            message.publicKey = String(object.publicKey);
        }
        else {
            message.publicKey = "";
        }
        if (object.options !== undefined && object.options !== null) {
            for (const e of object.options) {
                message.options.push(String(e));
            }
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.id !== undefined && (obj.id = message.id);
        message.publicKey !== undefined && (obj.publicKey = message.publicKey);
        if (message.options) {
            obj.options = message.options.map((e) => e);
        }
        else {
            obj.options = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgUpdateL3Node };
        message.options = [];
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        if (object.publicKey !== undefined && object.publicKey !== null) {
            message.publicKey = object.publicKey;
        }
        else {
            message.publicKey = "";
        }
        if (object.options !== undefined && object.options !== null) {
            for (const e of object.options) {
                message.options.push(e);
            }
        }
        return message;
    },
};
const baseMsgUpdateL3NodeResponse = {};
export const MsgUpdateL3NodeResponse = {
    encode(_, writer = Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgUpdateL3NodeResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const message = {
            ...baseMsgUpdateL3NodeResponse,
        };
        return message;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = {
            ...baseMsgUpdateL3NodeResponse,
        };
        return message;
    },
};
const baseMsgDeleteL3Node = { creator: "", id: 0 };
export const MsgDeleteL3Node = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.id !== 0) {
            writer.uint32(16).uint64(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgDeleteL3Node };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.id = longToNumber(reader.uint64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgDeleteL3Node };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = Number(object.id);
        }
        else {
            message.id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgDeleteL3Node };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        else {
            message.id = 0;
        }
        return message;
    },
};
const baseMsgDeleteL3NodeResponse = {};
export const MsgDeleteL3NodeResponse = {
    encode(_, writer = Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgDeleteL3NodeResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const message = {
            ...baseMsgDeleteL3NodeResponse,
        };
        return message;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = {
            ...baseMsgDeleteL3NodeResponse,
        };
        return message;
    },
};
const baseMsgCreateAttachedUser = {
    creator: "",
    iidapId: 0,
    account: 0,
    userName: "",
};
export const MsgCreateAttachedUser = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.iidapId !== 0) {
            writer.uint32(16).int32(message.iidapId);
        }
        if (message.account !== 0) {
            writer.uint32(24).int32(message.account);
        }
        if (message.userName !== "") {
            writer.uint32(34).string(message.userName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgCreateAttachedUser };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.iidapId = reader.int32();
                    break;
                case 3:
                    message.account = reader.int32();
                    break;
                case 4:
                    message.userName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgCreateAttachedUser };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.iidapId !== undefined && object.iidapId !== null) {
            message.iidapId = Number(object.iidapId);
        }
        else {
            message.iidapId = 0;
        }
        if (object.account !== undefined && object.account !== null) {
            message.account = Number(object.account);
        }
        else {
            message.account = 0;
        }
        if (object.userName !== undefined && object.userName !== null) {
            message.userName = String(object.userName);
        }
        else {
            message.userName = "";
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.iidapId !== undefined && (obj.iidapId = message.iidapId);
        message.account !== undefined && (obj.account = message.account);
        message.userName !== undefined && (obj.userName = message.userName);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgCreateAttachedUser };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.iidapId !== undefined && object.iidapId !== null) {
            message.iidapId = object.iidapId;
        }
        else {
            message.iidapId = 0;
        }
        if (object.account !== undefined && object.account !== null) {
            message.account = object.account;
        }
        else {
            message.account = 0;
        }
        if (object.userName !== undefined && object.userName !== null) {
            message.userName = object.userName;
        }
        else {
            message.userName = "";
        }
        return message;
    },
};
const baseMsgCreateAttachedUserResponse = {};
export const MsgCreateAttachedUserResponse = {
    encode(_, writer = Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgCreateAttachedUserResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const message = {
            ...baseMsgCreateAttachedUserResponse,
        };
        return message;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = {
            ...baseMsgCreateAttachedUserResponse,
        };
        return message;
    },
};
const baseMsgUpdateAttachedUser = {
    creator: "",
    iidapId: 0,
    account: 0,
    userName: "",
};
export const MsgUpdateAttachedUser = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.iidapId !== 0) {
            writer.uint32(16).int32(message.iidapId);
        }
        if (message.account !== 0) {
            writer.uint32(24).int32(message.account);
        }
        if (message.userName !== "") {
            writer.uint32(34).string(message.userName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgUpdateAttachedUser };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.iidapId = reader.int32();
                    break;
                case 3:
                    message.account = reader.int32();
                    break;
                case 4:
                    message.userName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgUpdateAttachedUser };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.iidapId !== undefined && object.iidapId !== null) {
            message.iidapId = Number(object.iidapId);
        }
        else {
            message.iidapId = 0;
        }
        if (object.account !== undefined && object.account !== null) {
            message.account = Number(object.account);
        }
        else {
            message.account = 0;
        }
        if (object.userName !== undefined && object.userName !== null) {
            message.userName = String(object.userName);
        }
        else {
            message.userName = "";
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.iidapId !== undefined && (obj.iidapId = message.iidapId);
        message.account !== undefined && (obj.account = message.account);
        message.userName !== undefined && (obj.userName = message.userName);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgUpdateAttachedUser };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.iidapId !== undefined && object.iidapId !== null) {
            message.iidapId = object.iidapId;
        }
        else {
            message.iidapId = 0;
        }
        if (object.account !== undefined && object.account !== null) {
            message.account = object.account;
        }
        else {
            message.account = 0;
        }
        if (object.userName !== undefined && object.userName !== null) {
            message.userName = object.userName;
        }
        else {
            message.userName = "";
        }
        return message;
    },
};
const baseMsgUpdateAttachedUserResponse = {};
export const MsgUpdateAttachedUserResponse = {
    encode(_, writer = Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgUpdateAttachedUserResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const message = {
            ...baseMsgUpdateAttachedUserResponse,
        };
        return message;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = {
            ...baseMsgUpdateAttachedUserResponse,
        };
        return message;
    },
};
const baseMsgDeleteAttachedUser = {
    creator: "",
    iidapId: 0,
    account: 0,
};
export const MsgDeleteAttachedUser = {
    encode(message, writer = Writer.create()) {
        if (message.creator !== "") {
            writer.uint32(10).string(message.creator);
        }
        if (message.iidapId !== 0) {
            writer.uint32(16).int32(message.iidapId);
        }
        if (message.account !== 0) {
            writer.uint32(24).int32(message.account);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseMsgDeleteAttachedUser };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.creator = reader.string();
                    break;
                case 2:
                    message.iidapId = reader.int32();
                    break;
                case 3:
                    message.account = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseMsgDeleteAttachedUser };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = String(object.creator);
        }
        else {
            message.creator = "";
        }
        if (object.iidapId !== undefined && object.iidapId !== null) {
            message.iidapId = Number(object.iidapId);
        }
        else {
            message.iidapId = 0;
        }
        if (object.account !== undefined && object.account !== null) {
            message.account = Number(object.account);
        }
        else {
            message.account = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.creator !== undefined && (obj.creator = message.creator);
        message.iidapId !== undefined && (obj.iidapId = message.iidapId);
        message.account !== undefined && (obj.account = message.account);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseMsgDeleteAttachedUser };
        if (object.creator !== undefined && object.creator !== null) {
            message.creator = object.creator;
        }
        else {
            message.creator = "";
        }
        if (object.iidapId !== undefined && object.iidapId !== null) {
            message.iidapId = object.iidapId;
        }
        else {
            message.iidapId = 0;
        }
        if (object.account !== undefined && object.account !== null) {
            message.account = object.account;
        }
        else {
            message.account = 0;
        }
        return message;
    },
};
const baseMsgDeleteAttachedUserResponse = {};
export const MsgDeleteAttachedUserResponse = {
    encode(_, writer = Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = {
            ...baseMsgDeleteAttachedUserResponse,
        };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const message = {
            ...baseMsgDeleteAttachedUserResponse,
        };
        return message;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = {
            ...baseMsgDeleteAttachedUserResponse,
        };
        return message;
    },
};
export class MsgClientImpl {
    constructor(rpc) {
        this.rpc = rpc;
    }
    CreateRollup(request) {
        const data = MsgCreateRollup.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "CreateRollup", data);
        return promise.then((data) => MsgCreateRollupResponse.decode(new Reader(data)));
    }
    UpdateRollup(request) {
        const data = MsgUpdateRollup.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "UpdateRollup", data);
        return promise.then((data) => MsgUpdateRollupResponse.decode(new Reader(data)));
    }
    DeleteRollup(request) {
        const data = MsgDeleteRollup.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "DeleteRollup", data);
        return promise.then((data) => MsgDeleteRollupResponse.decode(new Reader(data)));
    }
    CreateMessage(request) {
        const data = MsgCreateMessage.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "CreateMessage", data);
        return promise.then((data) => MsgCreateMessageResponse.decode(new Reader(data)));
    }
    UpdateMessage(request) {
        const data = MsgUpdateMessage.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "UpdateMessage", data);
        return promise.then((data) => MsgUpdateMessageResponse.decode(new Reader(data)));
    }
    DeleteMessage(request) {
        const data = MsgDeleteMessage.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "DeleteMessage", data);
        return promise.then((data) => MsgDeleteMessageResponse.decode(new Reader(data)));
    }
    CreateL3Node(request) {
        const data = MsgCreateL3Node.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "CreateL3Node", data);
        return promise.then((data) => MsgCreateL3NodeResponse.decode(new Reader(data)));
    }
    UpdateL3Node(request) {
        const data = MsgUpdateL3Node.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "UpdateL3Node", data);
        return promise.then((data) => MsgUpdateL3NodeResponse.decode(new Reader(data)));
    }
    DeleteL3Node(request) {
        const data = MsgDeleteL3Node.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "DeleteL3Node", data);
        return promise.then((data) => MsgDeleteL3NodeResponse.decode(new Reader(data)));
    }
    CreateAttachedUser(request) {
        const data = MsgCreateAttachedUser.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "CreateAttachedUser", data);
        return promise.then((data) => MsgCreateAttachedUserResponse.decode(new Reader(data)));
    }
    UpdateAttachedUser(request) {
        const data = MsgUpdateAttachedUser.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "UpdateAttachedUser", data);
        return promise.then((data) => MsgUpdateAttachedUserResponse.decode(new Reader(data)));
    }
    DeleteAttachedUser(request) {
        const data = MsgDeleteAttachedUser.encode(request).finish();
        const promise = this.rpc.request("cosmonaut.voter.voter.Msg", "DeleteAttachedUser", data);
        return promise.then((data) => MsgDeleteAttachedUserResponse.decode(new Reader(data)));
    }
}
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
function longToNumber(long) {
    if (long.gt(Number.MAX_SAFE_INTEGER)) {
        throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
    }
    return long.toNumber();
}
if (util.Long !== Long) {
    util.Long = Long;
    configure();
}
