package cli

import (
	"fmt"
	"time"

	"github.com/spf13/cobra"

	"github.com/cosmos/cosmos-sdk/client"
	// "github.com/cosmos/cosmos-sdk/client/flags"
	"github.com/cosmonaut/voter/x/voter/types"
)

var (
	DefaultRelativePacketTimeoutTimestamp = uint64((time.Duration(10) * time.Minute).Nanoseconds())
)

const (
	flagPacketTimeoutTimestamp = "packet-timeout-timestamp"
)

// GetTxCmd returns the transaction commands for this module
func GetTxCmd() *cobra.Command {
	cmd := &cobra.Command{
		Use:                        types.ModuleName,
		Short:                      fmt.Sprintf("%s transactions subcommands", types.ModuleName),
		DisableFlagParsing:         true,
		SuggestionsMinimumDistance: 2,
		RunE:                       client.ValidateCmd,
	}

	cmd.AddCommand(CmdCreateRollup())
	cmd.AddCommand(CmdUpdateRollup())
	cmd.AddCommand(CmdDeleteRollup())
	cmd.AddCommand(CmdCreateMessage())
	cmd.AddCommand(CmdUpdateMessage())
	cmd.AddCommand(CmdDeleteMessage())
	cmd.AddCommand(CmdCreateL3Node())
	cmd.AddCommand(CmdUpdateL3Node())
	cmd.AddCommand(CmdDeleteL3Node())
	cmd.AddCommand(CmdCreateAttachedUser())
	cmd.AddCommand(CmdUpdateAttachedUser())
	cmd.AddCommand(CmdDeleteAttachedUser())
	// this line is used by starport scaffolding # 1

	return cmd
}
