package types

import "encoding/binary"

var _ binary.ByteOrder

const (
	// AttachedUserKeyPrefix is the prefix to retrieve all AttachedUser
	AttachedUserKeyPrefix = "AttachedUser/value/"
)

// AttachedUserKey returns the store key to retrieve a AttachedUser from the index fields
func AttachedUserKey(
	iidapId int32,
	account int32,
) []byte {
	var key []byte

	iidapIdBytes := make([]byte, 4)
	binary.BigEndian.PutUint32(iidapIdBytes, uint32(iidapId))
	key = append(key, iidapIdBytes...)
	key = append(key, []byte("/")...)

	accountBytes := make([]byte, 4)
	binary.BigEndian.PutUint32(accountBytes, uint32(account))
	key = append(key, accountBytes...)
	key = append(key, []byte("/")...)

	return key
}
